Bug 119412 - Graphic Contextmenu in Writer, Calc, Draw and Impress
Summary: Graphic Contextmenu in Writer, Calc, Draw and Impress
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: All All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:6.2.0
Keywords:
Depends on:
Blocks: Context-Menu Unify-Across-Apps
  Show dependency treegraph
 
Reported: 2018-08-21 23:25 UTC by andreas_k
Modified: 2018-10-27 20:48 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments
Contextmenu Graphic in Writer and Draw (181.55 KB, image/png)
2018-08-21 23:25 UTC, andreas_k
Details
Contextmenu Graphic for Writer, Calc, Draw and Impress (226.92 KB, image/png)
2018-08-26 13:18 UTC, andreas_k
Details
Contextmenu Graphic for Writer, Calc, Draw and Impress (130.13 KB, image/png)
2018-08-26 20:22 UTC, andreas_k
Details
Contextmenu Graphic for Writer, Calc, Draw and Impress V3 (701.72 KB, image/png)
2018-08-29 08:01 UTC, andreas_k
Details

Note You need to log in before you can comment on or make changes to this bug.
Description andreas_k 2018-08-21 23:25:39 UTC
Created attachment 144359 [details]
Contextmenu Graphic in Writer and Draw

update Contextmenu when select Graphics in Draw and Writer

Writer
------
diff between 6.1 and proposal:

 - Paste Special (see BUG:119411)
 - Rotate was added (see BUG:115782)
 - Rotate or Flip was moved more up cause it's kind of edit stuff like crop, compress, ...

Draw
----
diff between 6.1 and proposal:

 - Position and Size was moved up (see BUG:119398)
 - Rotate was added cause it was added to all elements in Draw
 - Flip and Convert was moved up cause they are also edit stuff
 - Align was removed (see BUG:119409)
 - Edit Style was removed (didn't work, there are no Styles for graphics)
Comment 1 Heiko Tietze 2018-08-22 18:17:41 UTC
-1 to Paste Special in Writer (you cannot paste [special] onto images), as well as Rotate at the root level (a second click switches into the rotate mode), and I also see no need to move Rotate/Flip above the arrangements.

-1 to removal of Align in Draw, Rotate the same as above, and the repositioning as well. To drop Edit Style... is an option.

Two requests sneaked in here: Align in Draw (bug 119409) and Paste Special (bug 119412). I would make both a duplicate to this ticket and close it as WORKSFORME. Other opinions are welcome.
Comment 2 andreas_k 2018-08-26 13:18:53 UTC
Created attachment 144450 [details]
Contextmenu Graphic for Writer, Calc, Draw and Impress

Thanks for the feedback. I follow your feedback and this are the results of the differen LibO apps:

writer
------
- No change needed it's the "master layout for the other apps"

calc
----
- the image preparation stuff like crop, replace, compress, save should be out of the Image submenu like it is in writer, draw, impress
- Line, Area, Text, Position dialogues aren't available in any other apps and should be not visible here to.
- Group submenu is always empty and should not be available (only LeaveGroup command)
- Description and Name are not a very Common feature for our main users isn't it? It's also not available in writer or draw

draw
----
- Edit style didn't work so should removed
- Original Size is in the Position and Line Group like in the Calc proposal (the Crop, Replace, ... Save group is always the same looking.

impress
-------
- look like draw + Interaction
Comment 3 Maxim Monastirsky 2018-08-26 13:43:22 UTC
(In reply to andreas_k from comment #2)
> calc
> ----
> - Group submenu is always empty
It isn't empty if you select 2 images.

> - Description and Name are not a very Common feature for our main users
> isn't it? It's also not available in writer or draw
Please see the discussion in Bug 101193.

> draw
> ----
> - Edit style didn't work so should removed
It does work for me, and I don't think it's a good idea to remove it.
Comment 4 andreas_k 2018-08-26 14:35:41 UTC
(In reply to Maxim Monastirsky from comment #3)
> (In reply to andreas_k from comment #2)
> > calc
> > ----
> > - Group submenu is always empty
> It isn't empty if you select 2 images.

In draw when you select more than two items it show multiselect.xml but in writer and calc there is no multiselect.xml so it look like you are right, than group is needed. As the group submenu is only usefull when you select more than two items I would suggest to have the group commands outside a group group, cause then they will be shown only when it's usefull.
 
> > - Description and Name are not a very Common feature for our main users
> > isn't it? It's also not available in writer or draw
> Please see the discussion in Bug 101193.

So Description and Name should be in the calc context menu? than I will move it to the bottom.
 
> > draw
> > ----
> > - Edit style didn't work so should removed
> It does work for me, and I don't think it's a good idea to remove it.

you are right, area, line, rotate stuff work but the global style stuff not. So keep it in the context menu and hopefully get more functionality (better style support) in the future.
Comment 5 andreas_k 2018-08-26 20:22:35 UTC
Created attachment 144467 [details]
Contextmenu Graphic for Writer, Calc, Draw and Impress

again thanks for the feedback

From my point of view this is what I think what consistency should be.
Comment 6 Heiko Tietze 2018-08-27 07:05:49 UTC
Looks very promising now, good work.

(In reply to andreas_k from comment #2)
> - Line, Area, Text, Position dialogues aren't available in any other apps
> and should be not visible here to.

Or any other tool should show those options too? It might not suit images but the menu shows also up for shapes and making those transparent and color the area is core functionality. Furthermore, you place "Line" in the context menus of Impress/Draw, with good reasons. If the CM is too large we could put the commands in a submenu likewise done at the main menu.

Writer's "Properties..." is actually paragraph style and equivalent to "Edit Style" in Draw.

"Assign Macro" in Calc is an expert function and I would remove it. Similar for "Hyperlink"- the (extra) use case for Calc is a bit far-fetched and it's easy to access from the main menu or via shortcut.

"Align" in Calc is populated with options when you select more than one object. Keep it for consistency and as it is what you want to do with images rather than anything else.

Putting "Replace, Save, Compress, Edit" into an extra menu as it is today in Calc ("Image") seems to be a smart idea.


Btw, there are also toolbars Frame and Image that diverge heavily between modules.
Comment 7 andreas_k 2018-08-27 07:31:50 UTC
(In reply to Heiko Tietze from comment #6)
> Or any other tool should show those options too? It might not suit images
> but the menu shows also up for shapes and making those transparent and color
> the area is core functionality. Furthermore, you place "Line" in the context
> menus of Impress/Draw, with good reasons. If the CM is too large we could
> put the commands in a submenu likewise done at the main menu.

This contextmenu is ONLY for graphic and therefor Line, Area are not really usefull. In addition this items are available via Properties.
 
> "Assign Macro" in Calc is an expert function and I would remove it. Similar
> for "Hyperlink"- the (extra) use case for Calc is a bit far-fetched and it's
> easy to access from the main menu or via shortcut.

I'm very carefull when remove items cause ordinary there is ONE bug report how say it will destroy the workflow. However I will remove the two items.
 
> "Align" in Calc is populated with options when you select more than one
> object. Keep it for consistency and as it is what you want to do with images
> rather than anything else.

I suggest to have an contextmenu for multiselect see BUG 119526.
 
> Putting "Replace, Save, Compress, Edit" into an extra menu as it is today in
> Calc ("Image") seems to be a smart idea.

As this items are "core" actions for graphics and the context menu isn't that long I would suggest to have them all visible.

> Btw, there are also toolbars Frame and Image that diverge heavily between
> modules.

Than I have to have a look also at the toolbars when I'm finished with context menu. But first context menu.
Comment 8 andreas_k 2018-08-29 08:01:08 UTC
Created attachment 144530 [details]
Contextmenu Graphic for Writer, Calc, Draw and Impress V3

As everywhere else

First the items where you can edit the selected thing (graphic)
Than Size, position and Line (if available)
3rd the Align, Arrange, Rotate and Convert stuff (Rotate for writer and calc, rotate and convert for draw and impress)
Last the Properties and Style stuff.
Comment 9 andreas_k 2018-08-29 08:40:49 UTC
in the blog post you can read what was the idea to change graphic, draw, media, ole and form context menubar.

https://colibreoffice.wordpress.com/2018/08/29/context-menubar/
Comment 10 Maxim Monastirsky 2018-09-03 08:48:32 UTC
Also, it would be nice to replace the .uno:AlignFrameMenu submenu in Writer with .uno:ObjectAlign (I looked at the code and verified that they're do the same thing). This will add consistency with shapes and other apps, and also with the toolbar, as Jay replaced the commands in the toolbar with the ones from .uno:ObjectAlign - see https://cgit.freedesktop.org/libreoffice/core/commit/?id=24f50a40fc704b92a0aa6017f1877b4399926640
Comment 11 Commit Notification 2018-10-01 11:14:32 UTC
andreas kainz committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=fa39a342f848ecd840f59126d211602d31345d9f

tdf#119412 contextmenu graphic is now synced between different apps

It will be available in 6.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 12 Thomas Lendo 2018-10-27 20:48:16 UTC
Thanks, Andreas!
Verified fixed.

Version: 6.2.0.0.alpha1+
Build ID: 5d2ab49cbda1d7aea1019478abe0163e1f40a121
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: de-DE (de_DE.UTF-8); Calc: threaded
from today